package ip_2.lab1.items.api;

import com.fasterxml.jackson.annotation.JsonProperty;
import ip_2.lab1.types.repository.TypeRepository;
import ip_2.lab1.types.service.TypeService;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotNull;

import java.util.Objects;

public class ItemDto {
    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private Long id;
    @NotNull
    @Min(1)
    private Long typeId;
    @NotNull
    @Min(1)
    private Double price;
    @NotNull
    @Min(1)
    private Integer count;

    private Double benefit;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getTypeId() {
        return typeId;
    }

    public void setTypeId(Long typeId) {
        this.typeId = typeId;
    }

    public Double getPrice() {
        return price;
    }

    public void setPrice(Double price) {
        this.price = price;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Double getSum() {
        return price * count;
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Double getBenefit() {
        return benefit;
    }

    public void setBenefit(double benefit) {
        this.benefit = benefit;
    }
}
