package ip_2.lab1.items.model;

import io.swagger.v3.oas.models.security.SecurityScheme;
import ip_2.lab1.core.model.BaseEntity;
import ip_2.lab1.types.model.TypeEntity;
import jakarta.persistence.*;

import java.util.Objects;

@Entity
@Table(name = "items")
public class ItemEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "typeId", nullable = false)
    private TypeEntity type;
    @Column(nullable = false)
    private Integer price;
    @Column(nullable = false)
    private Integer count;

    public ItemEntity() {
    }

    public ItemEntity(TypeEntity type, Integer price, Integer count) {
        this.type = type;
        this.price = price;
        this.count = count;
    }

    public TypeEntity getType() {
        return type;
    }
    public void setType(TypeEntity type) {
        this.type = type;
    }

    public Integer getPrice() {
        return price;
    }
    public void setPrice(Integer price) {
        this.price = price;
    }

    public Integer getCount() {
        return count;
    }
    public void setCount(Integer count) {
        this.count = count;
    }

    @Override
    public int hashCode() { return Objects.hash(id, type, price, count); }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final ItemEntity other = (ItemEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getType(), type)
                && Objects.equals(other.getPrice(), price)
                && Objects.equals(other.getCount(), count);
    }
}
