package ip_2.lab1.items.repository;

import ip_2.lab1.items.model.ItemEntity;
import ip_2.lab1.items.model.ItemGrouped;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import java.util.List;

public interface ItemRepository extends CrudRepository<ItemEntity, Long> {
    List<ItemEntity> findByTypeId(long typeId);
    void deleteAllByTypeId(Long typeId);

    @Query("select t as type, coalesce(sum(i.price * i.count), 0) as totalPrice "
            + "from TypeEntity t left join ItemEntity i on i.type = t "
            + "group by t order by t.id")
    List<ItemGrouped> getItemsTotalByType();
}