package ip_2.lab1.reviews.model;

import ip_2.lab1.core.model.BaseEntity;
import ip_2.lab1.types.model.TypeEntity;
import ip_2.lab1.users.model.UserEntity;
import jakarta.persistence.*;
import org.h2.engine.User;
import org.hibernate.annotations.Cascade;

import java.util.Objects;

@Entity
@Table(name = "reviews")
public class ReviewEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "userId", nullable = false)
    private UserEntity user;
    @Column(nullable = false, length = 300)
    private String text;


    public ReviewEntity() {
    }
    public ReviewEntity(UserEntity user, String text) {
        this.user = user;
        this.text = text;
    }

    public UserEntity getUser() { return user;}
    public void setUser(UserEntity user) {
        this.user = user;
        if(!user.getReviews().contains(this))
            user.addReview(this);
    }
    public String getText() {
        return text;
    }
    public void setText(String text) {
        this.text = text;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, user, text);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final ReviewEntity other = (ReviewEntity) obj;
        return Objects.equals(other.getId(), id) && Objects.equals(other.getUser().getId(), user.getId())
                && Objects.equals(other.getText(), text);
    }
}
