package ip_2.lab1.reviews.repository;

import ip_2.lab1.reviews.model.ReviewEntity;
import ip_2.lab1.reviews.model.ReviewGrouped;
import ip_2.lab1.users.model.UserEntity;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface ReviewRepository extends CrudRepository<ReviewEntity, Long>, PagingAndSortingRepository<ReviewEntity, Long> {
    Page<ReviewEntity> findByUserId(Long userId, Pageable pageable);
    List<ReviewEntity> findByUserId(Long userId);
    void deleteAllByUserId(Long userId);

    @Query("SELECT u as user, count(*) as count FROM ReviewEntity r join UserEntity u on u = r.user group by user order by count DESC ")
    Page<ReviewGrouped> getReviewCountByUsers(Pageable pageable);

}
