package ip_2.lab1.types.model;

import ip_2.lab1.core.model.BaseEntity;
import ip_2.lab1.items.model.ItemEntity;
import jakarta.persistence.*;

import java.lang.reflect.Type;
import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

@Entity
@Table(name = "types")
public class TypeEntity extends BaseEntity {
    @Column(nullable = false, unique = true, length = 30)
    private String name;
    @Column(nullable = false, length = 10)
    private Integer basePrice;

    public TypeEntity() {
    }
    public TypeEntity(String name, Integer basePrice) {
        this.name = name;
        this.basePrice = basePrice;
    }

    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }

    public int getBasePrice() {
        return basePrice;
    }
    public void setBasePrice(int basePrice) {
        this.basePrice = basePrice;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, basePrice);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final TypeEntity other = (TypeEntity) obj;
        return Objects.equals(other.getId(), id) && Objects.equals(other.getName(), name)
                && Objects.equals(other.getBasePrice(), basePrice);
    }
}
